package br.com.fabricante.addon.exemplos.jobs;

import br.com.sankhya.modelcore.MGEModelException;
import br.com.sankhya.modelcore.util.BaseSPBean;

import javax.ejb.SessionBean;
/*

         obrigatrio seguir o padro abaixo para criar Jobs (Rotinas automatizadas executadas de tempos em tempos):

        A documentao  OBRIGATRIA!!!!!! Sem ela, o xdoclet no conseguir gerar suas interfaces e o servio nunca ser encontrado.

        1 - Nome da classe sempre termina com *SPBean.
        2 - @ejb.bean - Sempre ser o Nome da classe, mas termina somente com *SP.
        3 - jndi-name - Sempre ser o caminho completo para a classe, cujo nome seguir o padro acima, e sempre ser separado por "/".
        4 - type - Recomendado  stateless, caso deseje outro, consulte documentao.
        5 - transaction-type - Recomendado  "Container". Caso deseje outro, consulte documentao.
        6 - view-type - Sempre ser "local".
        7 - @ejb.transaction - Recomendado  "Supports". Caso deseje outro, consulte documentao.
        8 - @ejb.util - Recomendado  false. Caso deseje outro, consulte documentao.


        IMPORTANTE:  necessrio tambm editar o arquivo 'mgeschedule.xml'. Este arquivo est em model/resources/META-INF/mgeschedule.xml.
        Todo servio novo jbo deve ser declarado neste arquivo, caso contrrio, este no ser executado.

* */


/**
 * @ejb.bean name="ExemploJobSP"
 * jndi-name="br/com/fabricante/addon/exemplos/jobs/ExemploJobSP"
 * type="Stateless"
 * transaction-type="Container"
 * view-type="local"
 * @ejb.transaction type="Supports"
 * @ejb.util generate="false"
 */
public class ExemploJobSPBean extends BaseSPBean implements SessionBean {

    /*
         OBRIGATRIO criar o mtodo getScheduleConfig. Este mtodo sempre ir retornar uma String contendo o intervalo das execues.

        O intervalo dever ser retornado em milisegundos. Ex: 1 segundo so 1000 milisegundos. 1 hora so 3600000 milisegundos.

        A documentao  OBRIGATRIA!!!

        1 - @ejb.interface-method - Sempre ser "local".
    * */

    /**
     * @ejb.interface-method view-type = "local"
     */
    public String getScheduleConfig() throws java.lang.Exception {
        return "&1000";
    }


      /*
         OBRIGATRIO criar o mtodo onSchedule. Este  o mtodo onde a rotina ser executada.

        A documentao  OBRIGATRIA!!!

        1 - @ejb.interface-method
        2 - @ejb.transaction - Recomendado  "Supports". Caso deseje outro, consulte documentao.
    * */

    /**
     * @ejb.interface-method
     * @ejb.transaction type="Supports"
     */
    public void onSchedule() throws Exception, MGEModelException {
        System.out.println("Job Local foi chamado.");
    }
}
